【算法专题】双指针—三数之和

力扣题目链接:三数之和

一、题目解析

二、算法原理

解法一:排序+暴力枚举+利用set去重

代码就不写了,你们可以试着写一下

解法二:排序+双指针

这题和上一篇文章的两数字和方法类似

  1. 排序
  2. 固定一个数a
  3. 在这个数的后面区间,使用双指针找到两个数之和为-a即可

需要解决两个细节问题:

1. 去重(避免重复的三元组)

  • 找到一种结果后left和right要跳过重复的元素
  • 当双指针使用完跳出循环后,a也需要跳过重复的元素

去重的时候还要控制边界,避免越界的问题

2. 不漏(不漏掉任何一个满足条件的三元组)

找到一种结果后不要"停"(left++,right--),缩小区间,继续往后寻找。

三、代码编写

cpp 复制代码
class Solution {
public:
    vector<vector<int>> threeSum(vector<int>& nums) {
        vector<vector<int>> ret;
        //1.排序
        sort(nums.begin(), nums.end());

        int n = nums.size();
        //2.双指针
        for(int i = 0; i < n; )
        {
            if(nums[i] > 0) break;//小优化:大于0的直接退出循环不用往后找了
            int left = i + 1, right = n - 1, target = -nums[i];
            while(left < right)
            {
                int sum = nums[left] + nums[right];
                if(sum > target) right--;
                else if (sum < target) left++;
                else
                {
                    ret.push_back({nums[i], nums[left], nums[right]});
                    left++;
                    right--;
                    //去重left和right
                    while(left < right && nums[left] == nums[left - 1]) left++;
                    while(left < right && nums[right] == nums[right + 1]) right--; 
                }
            }
            i++;
            //去重i
            while(i < n && nums[i] == nums[i - 1]) i++;
        }
        return ret;
    }
};

这里还有个小优化,当a大于0的话可以不用在往后找,因为后面都是大于0的数,再怎么找也不会满足条件的。

相关推荐
飞Link1 小时前
什么是 AirSim?一文读懂无人机仿真平台
python·算法·无人机
xiaoye-duck3 小时前
《C++ 工具库实战》gflags 命令行参数解析库详解
c++·第三方库
一去不复返的通信er4 小时前
贪心算法-合并区间(LeetCode 56)
算法·leetcode·贪心算法
狂奔的sherry4 小时前
C++ 宏生成访问函数的代价:访问权限、调试和类型检查
c++·宏·编译·预处理器·类型检查
Shaoshing4 小时前
LeetCode100 49. 字母异位词分组
java·算法
YFJ_mily5 小时前
第二届区块链技术与基础模型国际学术会议(BTFM2027)
算法·区块链·能源·智能系统·rdlink研发家·机器人自动化
汤姆宝库5 小时前
收官深拆:第一性原理、产业电网与未来推演
大数据·人工智能·算法
划破黑暗的第一缕曙光5 小时前
[C++]:5.STL:string(2)
java·c++·redis
moshuying7 小时前
块扩散 + GDN 改造:Clover 把「并行生成」塞进了 Agent 的长上下文里
前端·算法